import { execa } from './index3.mjs';
import { d as defineCommand, L } from '../shared/nuxi.bd0a2fa0.mjs';
import { l as loadKit, w as writeTypes } from '../shared/nuxi.f56b6a0d.mjs';
import { t as tryResolveModule } from '../shared/nuxi.c6313488.mjs';
import { s as sharedArgs, l as legacyRootDirArgs, r as resolve } from '../shared/nuxi.cc8b5ffe.mjs';
import 'node:url';
import 'node:child_process';
import 'node:string_decoder';
import 'node:util';
import 'node:process';
import 'node:fs';
import 'node:tty';
import 'node:path';
import '../shared/nuxi.d62f547c.mjs';
import '../shared/nuxi.2155838d.mjs';
import 'child_process';
import 'path';
import 'fs';
import 'node:timers/promises';
import 'node:os';
import 'node:events';
import 'node:v8';
import 'node:stream';
import 'node:buffer';
import 'node:stream/promises';
import 'node:perf_hooks';
import '../shared/nuxi.eaa29140.mjs';
import './satisfies.mjs';
import '../shared/nuxi.00903207.mjs';
import '../shared/nuxi.8054e4da.mjs';
import 'node:module';
import '../shared/nuxi.deb0a220.mjs';
import 'node:assert';
import 'crypto';
import 'module';
import 'perf_hooks';
import 'os';
import 'vm';
import 'url';
import 'assert';
import 'process';
import 'v8';
import 'util';
import 'tty';
import 'node:fs/promises';
import 'node:crypto';
import '../shared/nuxi.15c58622.mjs';

const typecheck = defineCommand({
  meta: {
    name: "typecheck",
    description: "Runs `vue-tsc` to check types throughout your app."
  },
  args: {
    ...sharedArgs,
    ...legacyRootDirArgs
  },
  async run(ctx) {
    process.env.NODE_ENV = process.env.NODE_ENV || "production";
    const cwd = resolve(ctx.args.cwd || ctx.args.rootDir || ".");
    const {
      loadNuxt,
      buildNuxt,
      writeTypes: writeTypes$1 = writeTypes
    } = await loadKit(cwd);
    const nuxt = await loadNuxt({
      cwd,
      overrides: {
        _prepare: true,
        logLevel: ctx.args.logLevel
      }
    });
    await writeTypes$1(nuxt);
    await buildNuxt(nuxt);
    await nuxt.close();
    const [resolvedTypeScript, resolvedVueTsc] = await Promise.all([
      tryResolveModule("typescript"),
      tryResolveModule("vue-tsc/bin/vue-tsc.js")
    ]);
    if (resolvedTypeScript && resolvedVueTsc) {
      await execa(resolvedVueTsc, ["--noEmit"], {
        preferLocal: true,
        stdio: "inherit",
        cwd
      });
    } else {
      if (L) {
        await execa(
          "bun",
          "install typescript vue-tsc --global --silent".split(" "),
          { stdio: "inherit", cwd }
        );
        await execa("bunx", "vue-tsc --noEmit".split(" "), {
          stdio: "inherit",
          cwd
        });
      } else {
        await execa(
          "npx",
          "-p vue-tsc -p typescript vue-tsc --noEmit".split(" "),
          { stdio: "inherit", cwd }
        );
      }
    }
  }
});

export { typecheck as default };
